const STATUS_ICON_PATH = "chrome://msnmsgr/skin/status/";

var statusImages = {};
statusImages["NLN"] = "online.png";
statusImages["AWY"] = "away.png";
statusImages["BRB"] = "away.png";
statusImages["BSY"] = "busy.png";
statusImages["PHN"] = "busy.png";
statusImages["LUN"] = "busy.png";
statusImages["IDL"] = "idle.png";
statusImages["HDN"] = "offline.png";
statusImages["FLN"] = "offline.png";
statusImages["BLK"] = "blocked.png";

function onMainLoad() {
  window.controller = Controller;
  document.getElementById("email").focus();
}

function onMainUnload() {
  window.controller.logOut();
}

function onAddContactCommand() {
  window.controller.addNewContact();
}

function onBlockContactCommand() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  window.controller.blockContact(contactNode.id);
}

function onCancelSignInCommand() {
  window.controller.logOut();
}

function onChangeStatusCommand(aStatus) {
  window.controller.changeStatus(aStatus);
}

function onContactListDblClick(aTree, aEvent) {
  if (aEvent.button == 0) {
    var treeItem = aTree.view.getItemAtIndex(aTree.currentIndex);
    if (treeItem.parentNode.id == "online-contact-list") {
      window.controller.openSbSession(treeItem.firstChild.firstChild.id);
    }
    else if (treeItem.firstChild.firstChild.id == "emailItem") {
      window.controller.openEmailInbox();
    }
  }
}

function onDeleteContactCommand() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  window.controller.onDeleteContactRequest(contactNode.id, contactNode.getAttribute("label"));
}

function onEditListsCommand() {
  window.controller.openListsWindow();
}

function onEditPrefsCommand() {
  window.controller.openPrefsWindow();
}

function onSendEmailCommand() {
  var tree = document.getElementById("contact-list-tree");
  var treeItem = tree.view.getItemAtIndex(tree.currentIndex);
  var treeItemParent = treeItem.parentNode;
  if (treeItemParent.id == "online-contact-list" || treeItemParent.id == "offline-contact-list") {
    window.controller.openEmailMessageComposeForm(treeItem.firstChild.firstChild.id);
  }
}

function onSendImCommand() {
  var tree = document.getElementById("contact-list-tree");
  var treeItem = tree.view.getItemAtIndex(tree.currentIndex);
  if (treeItem.parentNode.id == "online-contact-list") {
    window.controller.openSbSession(treeItem.firstChild.firstChild.id);
  }
}

function onSignInCommand() {
  var email = document.getElementById("email");
  var status = document.getElementById("initial-status").value;
  var emailRegExp = /^.*\@.*\..*$/i;
  var validEmail = emailRegExp.exec(email.value);
  if (validEmail) {
    document.getElementById("signin-button").disabled = true;
    document.getElementById(status + "_menuitem").setAttribute("checked", true);
    document.getElementById("main-pages").selectedIndex = 1;
    window.controller.logIn(email.value, document.getElementById("password").value, status);
  }
  else {
    var title = window.bundle.GetStringFromName("error");
    var text = window.bundle.GetStringFromName("invalidEMail");
    promptService.alert(window, title, text);
  }
}

function onSignOutCommand() {
  window.controller.logOut();
}

function onViewContactProfileCommand() {
  var tree = document.getElementById("contact-list-tree");
  var treeItem = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (treeItem.id != "emailItem" && treeItem.id != "online" && treeItem.id != "offline") {
    window.open("http://members.msn.com/default.msnw?mem=" + treeItem.id, "_BLANK");
  }
}

function addContactToOfflineList(aContactId, aLabel, aStatusCode) {
  var offlineContactList = document.getElementById("offline-contact-list");
  var treeItem = document.createElement("treeitem");
  var treeRow = document.createElement("treerow");
  var contactNode = document.createElement("treecell");
  contactNode.setAttribute("id", aContactId);
  contactNode.setAttribute("label", " " + aLabel);
  contactNode.setAttribute("src", STATUS_ICON_PATH + statusImages[aStatusCode]);
  treeRow.appendChild(contactNode);
  treeItem.appendChild(treeRow);
  offlineContactList.appendChild(treeItem);
}

function moveContactToOfflineList(aContactId) {
  var offlineContactList = document.getElementById("offline-contact-list");
  var onlineContactList = document.getElementById("online-contact-list");
  var treeItem = document.getElementById(aContactId).parentNode.parentNode;
  var movingTreeItem = onlineContactList.removeChild(treeItem);
  offlineContactList.appendChild(movingTreeItem);
}

function moveContactToOnlineList(aContactId) {
  var offlineContactList = document.getElementById("offline-contact-list");
  var onlineContactList = document.getElementById("online-contact-list");
  var treeItem = document.getElementById(aContactId).parentNode.parentNode;
  var movingTreeItem = offlineContactList.removeChild(treeItem);
  onlineContactList.appendChild(movingTreeItem);
}

function removeContact(aContactId) {
  var treeItem = document.getElementById(aContactId).parentNode.parentNode;
  var contactList = treeItem.parentNode;
  contactList.removeChild(treeItem);
}

function reset() {
  var onlineContactList = document.getElementById("online-contact-list");
  while (onlineContactList.firstChild) {
    onlineContactList.removeChild(onlineContactList.firstChild);
  }
  var offlineContactList = document.getElementById("offline-contact-list");
  while (offlineContactList.firstChild) {
    offlineContactList.removeChild(offlineContactList.firstChild);
  }
  document.getElementById("signin-button").disabled = false;
  document.getElementById("signin-progress").value = 0;
  document.getElementById("sign-in-status").label = "";
  document.getElementById("main-pages").selectedIndex = 0;
}

function showContactList() {
  document.getElementById("main-pages").selectedIndex = 2;
}

function updateContact(aContactId, aLabel, aStatusCode) {
  var contactNode = document.getElementById(aContactId);
  contactNode.setAttribute("label", " " + aLabel);
  contactNode.setAttribute("src", STATUS_ICON_PATH + statusImages[aStatusCode]);
}

function updateDisplayName(aDisplayName) {
  document.getElementById("display-name").value = aDisplayName;
}

function updateNewEmailMessageCount(aNewEmailCountText) {
  window.document.getElementById("emailItem").setAttribute("label", aNewEmailCountText);
}

function updateProgressInfo(aProgressPercentage, aProgressText) {
  document.getElementById("signin-progress").value = aProgressPercentage;
  document.getElementById("sign-in-status").textContent = aProgressText;
}

function updateStatus(aStatusCode, aStatusText) {
  var statusImg = document.getElementById("status-image");
  var statusDesc = document.getElementById("status-description");
  statusImg.src = STATUS_ICON_PATH + statusImages[aStatusCode];
  statusDesc.value = aStatusText;
}

function closeSessionWindows() {
  var winEnum = winMediator.getEnumerator("msnmsgr:session");
  while (winEnum.hasMoreElements()) {
    var win = winEnum.getNext();
    win.close();
  }
}