function MsnObject(aPassport) {
  this.creator = aPassport;
  this.friendly = "";
  this.location = "";
  this.size = 0;
  this.type = 0;
  this.sha1d = "";
  this.sha1c = "";
  this.string = "";
}

MsnObject.prototype.fillInFromString = function(aString) {
  var fields = aString.substr(8, aString.length - 10).split(" ");
  for (var i = 0; i < fields.length; i++) {
    var fieldKeyLength = fields[i].indexOf("=");
    var fieldKey = fields[i].substr(0, fieldKeyLength);
    var fieldValuePos = fieldKeyLength + 2;
    var fieldValueLength = fields[i].length - fieldKeyLength - 3;
    var fieldValue = fields[i].substr(fieldValuePos, fieldValueLength);
    switch (fieldKey) {
      case "Creator": this.creator = fieldValue; break;
      case "Friendly": this.friendly = fieldValue; break;
      case "Location": this.location = fieldValue; break;
      case "Size": this.size = parseInt(fieldValue); break;
      case "Type": this.type = parseInt(fieldValue); break;
      case "SHA1D": this.sha1d = atob(fieldValue); break;
      case "SHA1C": this.sha1c = atob(fieldValue); break;
    }
  }
}

MsnObject.prototype.fillInFromDisplayPicture = function(aFile) {
  this.size = aFile.fileSize;
  this.type = 3;
  this.location = 0;
  this.friendly = "AAA="; // null
  var fileHash = Utils.getSha1HashFromFileAsBinary(aFile);
  this.sha1d = btoa(fileHash);
  var fieldsToHash = ["Creator", "Size", "Type", "Location", "Friendly",
                      "SHA1D"];
  var stringToHash = "";
  for (var i in fieldsToHash) {
    var field = fieldsToHash[i];
    stringToHash += field + this[field.toLowerCase()];
  }
  this.sha1c = Utils.getSha1HashFromStringAsBase64(stringToHash);
  this.string = "<msnobj ";
  for (var i in fieldsToHash) {
    var field = fieldsToHash[i];
    this.string += field + '="' + this[field.toLowerCase()] + '" ';
  }
  this.string += 'SHA1C="' + this.sha1c + '"/>';
}